%define anolis_release 2

%global pkgname aiosmtpd
%global summary Asyncio-based SMTP server
%global _description \
This is a server for SMTP and related protocols, similar in utility \
to the standard library’s smtpd.py module, but rewritten to be based \
on asyncio for Python 3.
%global srcname %{pkgname}

Name:           python-%{pkgname}
Version:        1.4.2
Release:        %{anolis_release}%{?dist}
Summary:        %{summary}

License:        ASL 2.0
URL:            https://github.com/aio-libs/aiosmtpd
Source0:        %{url}/archive/%{version}/%{pkgname}-%{version}.tar.gz

# Backports from upstream
Patch0001:      0001-Implement-Unthreaded-Controller-256.patch
Patch0002:      0002-Code-Hygiene-259.patch
Patch0003:      0003-URGENT-Fix-RTD-docs-gen.patch
Patch0004:      0004-Make-Sphinx-RTD-deps-SSOT.patch

# Avoid SSLError: Cannot create a client socket with a PROTOCOL_TLS_SERVER context
# Not merged yet when introduced here
Patch0005:      %{url}/pull/284.patch

BuildArch:      noarch

BuildRequires:  python%{python3_pkgversion}-devel >= 3.4
BuildRequires:  python%{python3_pkgversion}-setuptools
BuildRequires:  python%{python3_pkgversion}-atpublic
BuildRequires:  python%{python3_pkgversion}-pytest
BuildRequires:  python%{python3_pkgversion}-pytest-mock
# Required for tests
BuildRequires:  git-core

%description %{_description}


%package -n python%{python3_pkgversion}-%{pkgname}
Summary:        %{summary}
Requires:       python%{python3_pkgversion}-atpublic
%{?python_provide:%python_provide python%{python3_pkgversion}-%{pkgname}}

%description -n python%{python3_pkgversion}-%{pkgname} %{_description}


%prep
%autosetup -p1 -n %{srcname}-%{version}


%build
%py3_build


%install
%py3_install
# Cleanups
rm -rf %{buildroot}%{python3_sitelib}/examples
rm -f  %{buildroot}%{python3_sitelib}/aiosmtpd/docs/.gitignore


%check
# Tests don't seem to work properly in the build environment
# Cf. https://github.com/aio-libs/aiosmtpd/issues/277
%{__python3} -m pytest -v || :


%files -n python%{python3_pkgversion}-%{pkgname}
%{_bindir}/aiosmtpd
%{python3_sitelib}/*

%changelog
* Mon Mar 25 2024 Zhao Hang <wb-zh951434@alibaba-inc.com> - 1.4.2-2
- Rebuild with python3.11

* Sun May 07 2023 Funda Wang <fundawang@yeah.net> - 1.4.2-1
- Import package for anolis 23
